--
-- EuroInclusion
-- Specialization for EuroInclusion functionality
--
-- Modschmiede / LS-Modsource (Fast Coupler)
-- @author  Manuel Leithner
-- @date  08/08/09
--@date 22/05/12 Edit to Euro Inclusion by Michi

EuroInclusion = {};

function EuroInclusion.prerequisitesPresent(specializations)
    Vehicle.registerJointType("EuroInclusion");
	return true;
end;



function EuroInclusion:load(xmlFile)
	_=[[
    local i=0;
    while true do
        local baseName = string.format("vehicle.attacherJoints.attacherJoint(%d)", i);
        local index = getXMLString(xmlFile, baseName.. "#index");
        if index == nil then
            break;
        end;	

		local jointTypeStr = getXMLString(xmlFile, baseName .. "#jointType");
		if jointTypeStr ~= nil then
			local jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
			
			if jointType == nil then
				Vehicle.registerJointType(jointTypeStr);
				print("register Jointtype: " .. jointTypeStr);
				jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
			end;
			
			if jointType ~= nil then
				self.attacherJoints[i+1].jointType = jointType;				
			end;
		end;
		i = i + 1;
	end;	]]	
	

	--[[local jointTypeStr = getXMLString(xmlFile,"vehicle.attacherJoints.attacherJoint#jointType");
	if jointTypeStr ~= nil then
		local jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
		
		if jointType == nil then
			Vehicle.registerJointType(jointTypeStr);
			print("register Jointtype: " .. jointTypeStr);
			jointType = Vehicle.jointTypeNameToInt[jointTypeStr];
		end;
		
		if jointType ~= nil then
			self.attacherJoints[1].jointType = jointType;				
		end;
	end; ]]--
	
	self.attacherJoints[1].jointType = Vehicle.JOINTTYPE_EUROINCLUSION;

	self.attacherVehicleCopy = nil;
	
end;

function EuroInclusion:delete()
end;

function EuroInclusion:mouseEvent(posX, posY, isDown, isUp, button)
end;

function EuroInclusion:keyEvent(unicode, sym, modifier, isDown)
end;

function EuroInclusion:update(dt)	
end;

function EuroInclusion:draw()
end;

function EuroInclusion:onAttach(attacherVehicle)
	self.attacherVehicleCopy = attacherVehicle;
    for k,v in pairs(self.attachedImplements) do	
		if v.object.onEuroInclusionAttach ~= nil then
            v.object:onEuroInclusionAttach(attacherVehicle);
		end;
    end;
end;

function EuroInclusion:onDetach()
	self.attacherVehicleCopy = nil;
	for k,v in pairs(self.attachedImplements) do
		if v.object.onEuroInclusionDetach ~= nil then
            v.object:onEuroInclusionDetach(attacherVehicle);
		end;
    end;
end;
